'''
Utilities for handling 'files' section
'''

import os
import re

def get_file(section, name):
    '''
    Expand input files into full file names
    '''

    # Create section list
    parent = section
    ancestry = [parent]
    while not parent.parent is parent:
        ancestry.append(parent.parent)
        parent = parent.parent
    ancestry.reverse()

    # Extract directory name   
    dir_name = '' 
    for parent in ancestry:
        if '.base_dir' in parent:
            dir_name = parent['.base_dir']
        elif '.sub_dir' in parent:
            dir_name = os.path.join(dir_name, parent['.sub_dir'])

    result = os.path.join(dir_name, section.get(name))
    result = re.sub(r'\$\{(\w+)\}', lambda m: section.main[m.group(1)], result)

    return result
